<?php
if ( ! defined( 'ABSPATH' ) ) {
  exit; // Exit if accessed directly
}

$general_appearance = get_option('wpsc_appearance_general_settings');
$wpsc_appearance_modal_window = get_option('wpsc_modal_window');
?>

<div class="wpsc-iso">
  
  <h3>
    <?php _e('Tickets','supportcandy');?>
  </h3>
  
  <div id="wpsc_tickets_container" class="row" style="border-color:<?php echo esc_attr($general_appearance['wpsc_action_bar_color'])?> !important;"></div>
  
  <div id="wpsc_alert_success" class="alert alert-success wpsc_alert" style="display:none;" role="alert">
    <i class="fa fa-check-circle"></i> <span class="wpsc_alert_text"></span>
  </div>
  
  <div id="wpsc_alert_error" class="alert alert-danger wpsc_alert" style="display:none;" role="alert">
    <i class="fa fa-exclamation-triangle"></i> <span class="wpsc_alert_text"></span>
  </div>
  
</div>

<!-- Pop-up snippet start -->
<div id="wpsc_popup_background" style="display:none;"></div>
<div id="wpsc_popup_container" style="display:none;">
  <div class="wpsc-iso">
    <div class="row">
      <div id="wpsc_popup" class="col-xs-10 col-xs-offset-1 col-sm-10 col-sm-offset-1 col-md-8 col-md-offset-2 col-lg-6 col-lg-offset-3">
        <div id="wpsc_popup_title" class="row" style="background-color:<?php echo esc_attr($wpsc_appearance_modal_window['wpsc_header_bg_color'])?> !important;color:<?php echo esc_attr($wpsc_appearance_modal_window['wpsc_header_text_color'])?> !important;"><h3><?php _e('Modal Title','supportcandy');?></h3></div>
        <div id="wpsc_popup_body" class="row"><?php _e('I am body!','supportcandy');?></div>
        <div id="wpsc_popup_footer" class="row" style="background-color:<?php echo esc_attr($wpsc_appearance_modal_window['wpsc_footer_bg_color'])?> !important;">
          <button type="button" class="btn wpsc_popup_close" ><?php _e('Close','supportcandy');?></button>
          <button type="button" class="btn wpsc_popup_action"><?php _e('Save Changes','supportcandy');?></button>
        </div>
      </div>
    </div>
  </div>
</div>
<!-- Pop-up snippet end -->

<?php
add_action('admin_footer', 'wpsc_page_inline_script');
global $attrs;
$attrs = isset($attr['page'])? $attr['page']:'init';
?>
<script>
  var wpsc_setting_action = '<?php echo esc_attr($attrs)?>';
</script>

<?php
function wpsc_page_inline_script(){
  ?>
  <script>
  <?php
     $url_attrs = array();
     foreach ($_GET as $key => $value) {

        $key = sanitize_text_field($key);
        $value = sanitize_text_field($value);
        $url_attrs[$key] = $value;
     }
  ?>
       var attrs = <?php echo wp_json_encode($url_attrs)?>;
       
       jQuery(document).ready(function(){
         wpsc_init(wpsc_setting_action,attrs);
       });
  </script>
  <?php
}
?>